/*
 * This work is licensed under the Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Switzerland License. To view a copy of this license, visit
 * http://creativecommons.org/licenses/by-nc-sa/2.5/ch/ or send a letter to Creative Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.
 */

package ch.njol.skript.effects;

import java.util.List;
import java.util.regex.Matcher;

import org.bukkit.entity.LivingEntity;
import org.bukkit.event.Event;

import ch.njol.skript.Skript;
import ch.njol.skript.api.Effect;
import ch.njol.skript.api.Variable;

/**
 * @author Peter Gttinger
 * 
 */
public class EffKill extends Effect {
	
	static {
		Skript.addEffect(EffKill.class, "kill %livingentity%");
	}
	
	private Variable<LivingEntity> entities;
	
	@SuppressWarnings("unchecked")
	@Override
	public void init(final List<Variable<?>> vars, final int matchedPattern, final Matcher matcher) {
		entities = (Variable<LivingEntity>) vars.get(0);
	}
	
	@Override
	protected void execute(final Event e) {
		for (final LivingEntity entity : entities.get(e)) {
			entity.setHealth(0);
		}
	}
	
	@Override
	public String getDebugMessage(final Event e) {
		return "kill " + entities;
	}
	
}
